# flake8: noqa

"""
    Stocks API For Digital Portals

    The stocks API features a screener to search for equity instruments based on stock-specific parameters.  Parameters for up to three fiscal years might now be used in one request; data is available for the ten most recent completed fiscal years. Estimates are available for the current and two consecutive fiscal years.  A separate endpoint returns the possible values and value ranges for the parameters that the endpoint /stock/notation/screener/search accepts: Application developers can request the values and value ranges only for a restricted set of notations that match predefined parameters. This functionality may be used to pre-fill the values and value ranges of the parameters of the /stock/notation/screener/search endpoint so that performing a search always leads to a non-empty set of notations.  The endpoint /stock/notation/ranking/intraday/list ranks stocks notations using intraday figures, for example to build a gainers/losers list.   Additional endpoints include end-of-day benchmark key figures, and selected fundamentals (as of end of fiscal year and with potentially daily updates).  This API is fully integrated with the corresponding Quotes API, allowing access to detailed price and performance information of instruments, as well as basic security identifier cross-reference. For direct access to price histories, please refer to the Time Series API for Digital Portals.  Similar criteria based screener APIs exist for fixed income instruments and securitized derivatives: See the Bonds API and the Securitized Derivatives API for details.  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


__version__ = "0.10.1"

# import ApiClient
from fds.sdk.StocksAPIforDigitalPortals.api_client import ApiClient

# import Configuration
from fds.sdk.StocksAPIforDigitalPortals.configuration import Configuration

# import exceptions
from fds.sdk.StocksAPIforDigitalPortals.exceptions import OpenApiException
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiAttributeError
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiTypeError
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiValueError
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiKeyError
from fds.sdk.StocksAPIforDigitalPortals.exceptions import ApiException
